Updated: 2012-06-18 Due date:
Has patch: No
Affected Flow version: Git master
Subject: hidden fields should be rendered in extra section
Description

The form.checkbox view helper works in an unexpected way because it creates two, rather than one <input> elements.

This is a problem when using markup like

<label>
  <f:form.checkbox ...>
  Checkbox name
</label>

as one ends up having two <input>s inside the <label> which is invalid HTML. One has to make the effort to create id and for
attributes for both tags to get things working correctly. This could be simpler.

In the long term it may be worth considering to add explicit support for <label> tags to the form field view helpers, to encourage label
usage by offering straightforward support for it from the templating engine.

UPDATE: The solution would be to render the "automatically generated" hidden fields for checkboxes and select dropdowns in the
hidden fields section at the beginning of a form

Related issues:
related to TYPO3.Fluid - Bug # 33628: Multicheckboxes (multiselect) for Colle... Needs Feedback2012-02-02
related to TYPO3.Fluid - Task # 13342: f:form.checkbox does only render hidde... Resolved 2011-02-24

Associated revisions
Revision f25fa5fb - 2012-05-26 21:27 - Bastian Waidelich

[BUGFIX] hidden fields should be rendered in extra section

Currently form.select and form.checkbox ViewHelpers render
hidden fields before the actual input field in order to
force submission of a value.
This leads to the situation that labels wrapped around the
field do not correspond to the actual form field, but to
the hidden field.
This is fixed by letting the form ViewHelper taking care of
rendering the requried hidden fields in the already existing
section on top of the form.

Change-Id: I77cc9061a36d2a2984bf479868b1138c513e47f8
Fixes: #26481
Fixes: #13342
Releases: 1.1, 1.2

Revision 9f01a42d - 2012-06-18 11:36 - Bastian Waidelich

[BUGFIX] hidden fields should be rendered in extra section

Currently form.select and form.checkbox ViewHelpers render
hidden fields before the actual input field in order to
force submission of a value.
This leads to the situation that labels wrapped around the
field do not correspond to the actual form field, but to
the hidden field.
This is fixed by letting the form ViewHelper taking care of
rendering the requried hidden fields in the already existing
section on top of the form.

Change-Id: I77cc9061a36d2a2984bf479868b1138c513e47f8
Fixes: #26481
Fixes: #13342
Releases: 1.1, 1.2

History
#1 - 2011-04-29 10:01 - Bastian Waidelich
- Status changed from New to Needs Feedback
- Assigned To set to Bastian Waidelich

Sven-S. Porst wrote:

as one ends up having two <input>s inside the <label> which is invalid HTML.

Why do you think, that this is invalid HTML?
Try to validate this:

<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" 
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
 <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
 <head>
    <title>Form test</title>
    <meta http-equiv="Content-Type" content="application/xhtml+xml; charset=UTF-8" />
    <meta http-equiv="Content-Style-Type" content="text/css" />
 </head>
 <body>
    <form action="foo" method="post">
        <ul>
            <li>
                <label>Foo <input type="hidden" name="foo" value="" /><input type="checkbox" name="foo" value="bar" /></label>
            </li>
        </ul>
    </form>
</body>
</html>

on http://validator.w3.org/#validate_by_input

#2 - 2011-04-29 10:17 - Sven-S. Porst

Try validating against HTML 5.

Besides: If you're using the markup in your example you'll notice that it doesn't work as expected – clicking the label will not select the checkbox
(presumably because the browser implicitly associates the label to the first <input> element it contains in this ambiguous situation). So it's poor
usability which is how I found this problem to begin with. In fact, I'm surprised doing this was valid in HTML 4.

#3 - 2011-04-29 12:27 - Bastian Waidelich

Sven-S. Porst wrote:

Try validating against HTML 5.
[...] it doesn't work as expected [...]

Good point(s) ;)
I'm not sure how to solve this though.. I don't think, that the form view helper should output the label, because then you'd have to be able to specify
some kind of template for the exact output.
Maybe a solution would be to make the hidden field optional (<f:form.checkbox createHiddenField="false" />) so that you'd be able to render it
yourself. To avoid a lot of duplicate template code, you could put this into a partial:

1<li>
2    <f:form.hidden property="{property}" value="" />
3    <label>
4        {label}
5        <f:form.checkbox property="{property}" createHiddenField="false" />
6    </label>
7</li>

and use it like:

1<f:render partial="Checkbox" arguments="{property: 'foo', label: 'Foo'} />

what do you think?
#4 - 2011-04-29 12:43 - Sven-S. Porst

The createHiddenField approach would certainly help with my specific problem.

On the other hand, adding an extra paramter would add addional complexity to the view helper's interface, so I'm not sure this is a really good solution
if the templating is meant to be easy to use.

If one needs those hidden fields, a more elegant solution would be if the hidden fields were not inserted directly by the form field's view helper but
collected by the containing form view helper and then inserted at the beginning of the form.

#5 - 2011-04-29 13:44 - Bastian Waidelich
- Assigned To changed from Bastian Waidelich to Sebastian Kurfuerst

Sven-S. Porst wrote:

[...] a more elegant solution would be if the hidden fields were not
inserted directly by the form field's view helper but collected by the containing
form view helper and then inserted at the beginning of the form.

I like this idea. The form already renders a section with hidden fields anyways.. Assigning this to Sebastian so he can give his input. @Sebastian feel
free to re-assign this to me

#6 - 2011-04-29 16:56 - Sebastian Kurfuerst
- Assigned To changed from Sebastian Kurfuerst to Bastian Waidelich

Nice idea! However it must be at the beginning of the form. I am not sure, if the referrers are added before or after?

So, +1 to changing it so they are added at the beginning of the form!

Greets,
Sebastian

#7 - 2011-05-02 08:42 - Sven-S. Porst

The referrers are inserted at the beginning of the form. So the setup seems to be just right.

#8 - 2011-05-06 10:08 - Sebastian Kurfuerst
- Parent task set to #26658

#9 - 2011-09-09 15:20 - Robert Lemke
- Target version changed from 1.0 beta 2 to 1.0.0

#10 - 2011-09-13 09:41 - Bastian Waidelich
- Subject changed from form field view helpers could do with better support for <label> to render fluid hidden fields in extra section
- Has patch set to No
#11 - 2011-09-13 10:19 - Bastian Waidelich
- Status changed from Needs Feedback to Accepted

#12 - 2011-10-20 01:48 - Karsten Dambekalns
- Target version deleted (1.0.0)

#13 - 2012-05-08 18:57 - Bastian Waidelich
- Target version set to 1.1

#14 - 2012-05-25 09:40 - Karsten Dambekalns
- Target version changed from 1.1 to 1.1 RC1

#15 - 2012-05-26 09:35 - Bastian Waidelich

Sorry for the delay on this one. I take care of implementing this for 1.1!

#16 - 2012-05-26 21:22 - Bastian Waidelich
- Tracker changed from Task to Bug
- Subject changed from render fluid hidden fields in extra section to hidden fields should be rendered in extra section
- Affected Flow version set to Git master

#17 - 2012-05-26 21:27 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/11648

#18 - 2012-05-29 08:52 - Sebastian Kurfuerst
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

#19 - 2012-06-18 11:36 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch FLOW3-1.1 has been pushed to the review server.
It is available at http://review.typo3.org/12158

#20 - 2012-06-18 17:38 - Bastian Waidelich
- Status changed from Under Review to Resolved

Applied in changeset commit:9f01a42dc97a85f22a08c4d7ca75405fe1e75557.
